#include <iostream>
#include <bits/stdc++.h>
using namespace std;

int poslednji_i(int m[][2000], int n, int c)
{
    for(int i=n-1; i>=0; i--)
        {
            for(int j=n-1; j>=0; j--)
            {
                if(m[i][j]==c){return i;}
            }
        }
}

int poslednji_j(int m[][2000], int n, int c)
{
    for(int i=n-1; i>=0; i--)
        {
            for(int j=n-1; j>=0; j--)
            {
                if(m[i][j]==c){return j;}
            }
        }
}

int podniz_l(int m[][2000],int i1, int j1, int i2, int j2, int c)
{
    int l=0;
    for (int i=i1; i<i2+1; i++)
    {
        for (int j=j1; j<j2+1; j++)
        {
            if(m[i][j]==c) l++;
        }
    }
    return l;
}

void podniz(int m[][2000],int n, int c)
{
    for (int i=0; i<n; i++)
    {
        for (int j=0; j<n; j++)
        {
            if(m[i][j]==c) m[i][j]=0;
        }
    }
}

int main()
{
    int n,c=0;
    long k;
    cin >> n >>k;
    int m[n][2000];

    for (int i=0; i<n; i++)
    {
        for(int j=0; j<n; j++)
        {
            cin >>m[i][j];
        }
    }

    for (int i1=0; i1<n; i1++)
    {
        for(int j1=0; j1<n; j1++)
        {
            if(m[i1][j1]!=0){
                int k=m[i1][j1];
                int i2=poslednji_i(m,n,m[i1][j1]);
                int j2=poslednji_j(m,n,m[i1][j1]);
                int l=podniz_l(m,i1,j1,i2,j2,m[i1][j1]);
                podniz(m,n,m[i1][j1]);
                if(l==(i2-i1+1)*(j2-j1+1)) c++;
            }
        }
    }
    cout << c;
    return 0;
}